Scriptname TissHeadTrack extends Quest   

static property ObjetInvisible auto
actor property PlayerRef auto

globalvariable property Key_Camera auto
globalvariable property Key_Pause auto
globalvariable property Key_Ecran auto
globalvariable property Key_Switch auto
globalvariable property DisableWeapon auto
globalvariable property DisableNotifications auto
globalvariable property Invert360 auto
globalvariable property AutoDialogue auto

globalvariable property CameraComplet auto
globalvariable property Camera180 auto
globalvariable property CameraHybride auto

globalvariable property EcranComplet auto
globalvariable property Ecran180 auto
globalvariable property EcranHybride auto


function MoveObjectToCamera(ObjectReference obj) global native
function MoveObjectToView(ObjectReference obj) global native

float UpdateDelay = 0.1
ObjectReference DummyObject

Int Key_Switch_ = 0
bool IsActive_=false
Int property ExpressionId =0  auto
Int property ExpressionValue =0  auto
bool property IsThirdPerson =false  auto
Int property MoveCamX =0  auto
Int property MoveCamZ =-5  auto
Int property MoveCamY = 80  auto
bool property IsMoveCamera =false  auto
bool property IsSetExpression =false  auto

; bool property IsLongMoveCamera =false  auto
Int property LongMoveCamX =0  auto
Int property LongMoveCamZ =-50  auto
Int property LongMoveCamY =210  auto


Float property InAngle =90.0  auto
Float property OutAngle =90.0  auto

Int[] property Phonemes  auto ;0~15
Int[] property Modifiers  auto ;0~13

float camx
float camZ
float camYMin
float camYMax


Bool HasPlayerHeadTrackingWhenStart = False
; Bool IsPlayerHeadTrackingExists = False
String PlayerHeadTrackingEsp = "PC Head Tracking - MCM.esp"
function OnInit()
	debug.notification("Init")
	DummyObject = none
    Phonemes=new Int[16]
    Modifiers=new Int[14]
    OnLoad_()
endFunction
function Reset()
	debug.notification("Reset")
    ExpressionId =0  
    ExpressionValue =0  
    IsThirdPerson =false  
    MoveCamX =0  
    MoveCamZ =-5  
    MoveCamY = 80  
    IsMoveCamera =false  
    IsSetExpression =false  

    LongMoveCamX =0  
    LongMoveCamZ =-50  
    LongMoveCamY =210  

    InAngle =90.0  
    OutAngle =90.0  

    Phonemes  = None
    Modifiers  = None
endfunction
function ReRegisterKey(Int unregisterKey, Int registerKey)
	if unregisterKey != 0
		UnregisterForKey(unregisterKey)
	endIf
	RegisterForKey(registerKey)
endFunction

function OnLoad_()
	Key_Switch_ = Key_Switch.GetValue() as Int
    Debug.Trace(Phonemes.Length+" fdzxcf "+Modifiers.Length)
    if Phonemes.Length==0
        Phonemes=new Int[16]
    endif
    if Modifiers.Length==0
        Modifiers=new Int[14]
    endif
    RegisterforCameraState()
    ReRegisterAllKeys()
    int camState=Game.GetCameraState()
    IsThirdPerson = camState == 8 || camState == 9

    if IsActive_
        StopLookCam()
    endif
endfunction

function ReRegisterAllKeys()
    ReRegisterKey(Key_Switch_, Key_Switch.GetValue() as Int)
    Key_Switch_ = Key_Switch.GetValue() as Int
EndFunction

function OnPlayerCameraState(Int oldState, Int newState)
    IsThirdPerson = newState == 8 || newState == 9
endFunction

function OnAnimationEvent(ObjectReference akSource, String asEventName)
    StopLookCam()
endFunction

function StopLookCam()
    if !IsActive_ 
        return 
    endif
    ; PlayerRef.SetAnimationVariableBool("IsNPC", false)
    PlayerRef.SetLookAt(PlayerRef, false)
    PlayerRef.ClearLookAt()
    PlayerRef.SetHeadTracking(false)
    IsActive_=false

    
    if IsSetExpression
        PlayerRef.ClearExpressionOverride()
        MfgConsoleFunc.ResetPhonemeModifier(PlayerRef)
    endif


    if IsMoveCamera
        SetShoulderCamPos(camx,camZ,camYMin,camYMax)
    endif
    if HasPlayerHeadTrackingWhenStart
        Spell spell_ =Game.GetFormFromFile(0x2001, PlayerHeadTrackingEsp) as Spell
        PlayerRef.AddSpell(spell_,false)
    endif
    ; UnregisterForKey(264)
    ; UnregisterForKey(265)
endfunction

function StartLookCam()
    ;============ START ===============
    bool IsPlayerHeadTrackingExists = (Game.GetModByName(PlayerHeadTrackingEsp) != 255)
    if IsPlayerHeadTrackingExists
        Spell spell_ = Game.GetFormFromFile(0x2001, PlayerHeadTrackingEsp) as Spell
        HasPlayerHeadTrackingWhenStart = PlayerRef.HasSpell(spell_)
        if HasPlayerHeadTrackingWhenStart
            PlayerRef.RemoveSpell(spell_)
            Utility.Wait(0.1) ;so clean up scripts finished
        endif
    endif


    IsActive_=true
    PlayerRef.SetAnimationVariableBool("IsNPC", true)
    PlayerRef.SetHeadTracking(true)
    PlayerRef.SetLookAt(DummyObject, false)

    if IsSetExpression    
        PlayerRef.SetExpressionOverride(ExpressionId, ExpressionValue)
        int i = 0
        while i < 16
            MfgConsoleFunc.SetPhoneme(PlayerRef,i,Phonemes[i])
            i+=1
        endWhile
        i = 0
        while i < 14
            MfgConsoleFunc.SetModifier(PlayerRef,i,Modifiers[i])
            i+=1
        endWhile
    endif



    if IsMoveCamera
        GetShoulderCamPos()
        SetShoulderCamPos(MoveCamX,MoveCamZ,MoveCamY)
        ; if IsLongMoveCamera
        ;     RegisterForKey(264)
        ;     RegisterForKey(265)
        ;     ; 0x108  264  Mouse Long Up
        ;     ; 0x109  265  Mouse Long Down
        ; endif
    endif
    
    RegisterForSingleUpdate(UpdateDelay)
endfunction
float KeyDownTime=0.0
function OnKeyUp(Int KeyCode, Float HoldTime)
    If KeyCode == Key_Switch_
        KeyDownTime=0.0
    ; if IsActive_
        ; IsKeyDown=false
    ; endif
    endIf
endfunction
function OnKeyDown(Int KeyCode)
    If KeyCode == Key_Switch_
        KeyDownTime=utility.GetCurrentRealTime()
        if Utility.IsInMenuMode()
            return 
        endif 

        if IsActive_ 
            StopLookCam()
            return
        endif
        if DummyObject == none
            DummyObject = PlayerRef.PlaceAtMe(ObjetInvisible as form, 1, false, false)
        endIf


        MoveObjectToCamera(DummyObject)
        float angle=math.abs(PlayerRef.GetHeadingAngle(DummyObject))
        if angle < InAngle
            StartLookCam()
        endIf
    endIf
endFunction

Function GetShoulderCamPos()
    camx= utility.GetINIFloat("fOverShoulderPosX:Camera")
    camZ= utility.GetINIFloat("fOverShoulderPosZ:Camera")
    camYMin= utility.GetINIFloat("fVanityModeMinDist:Camera")
    camYMax= utility.GetINIFloat("fVanityModeMaxDist:Camera")
    game.UpdateThirdPerson()
EndFunction

Function SetShoulderCamPos(float camx_,float CamZ_,float camYMin_,float camYMax_=0.0)
    if camYMax_==0.0
        camYMax_=camYMin_
    endif

    utility.SetINIFloat("fOverShoulderPosX:Camera", camx_)
    utility.SetINIFloat("fOverShoulderPosZ:Camera", CamZ_)

    if camYMin_!=0.0
        utility.SetINIFloat("fVanityModeMinDist:Camera", camYMin_)
        utility.SetINIFloat("fVanityModeMaxDist:Camera", camYMax_)
    endif

    game.UpdateThirdPerson()
EndFunction

function SetExpression(int id,int val)
    ; Debug.Notification("expression:"+id+", "+val)
    ExpressionId=id
    ExpressionValue=val
endfunction

function OnUpdate()
    ; Debug.Trace(""+IsActive_+", "+(DummyObject==None)+", "+(PlayerREF.GetAnimationVariableBool("IsNPC") == false) +", "+ (UI.IsMenuOpen("Dialogue Menu"))+", "+ !IsThirdPerson)
    if !IsActive_
        return 
    endif
    if DummyObject == none  || (UI.IsMenuOpen("Dialogue Menu")) || !IsThirdPerson
        StopLookCam()
        return 
    endif 

    if !PlayerREF.GetAnimationVariableBool("IsNPC")
        PlayerRef.SetAnimationVariableBool("IsNPC", true)
        PlayerRef.SetHeadTracking(true)
        PlayerRef.SetLookAt(DummyObject, false)
    endif
    ; Debug.Trace("KeyDownTime:"+KeyDownTime+", "+(utility.GetCurrentRealTime()-KeyDownTime), 0)
    if KeyDownTime != 0.0 && (utility.GetCurrentRealTime()-KeyDownTime>1)
        KeyDownTime=0
        SetShoulderCamPos(LongMoveCamX,LongMoveCamZ,LongMoveCamY)
    endif
    
    MoveObjectToCamera(DummyObject)
    float angle=math.abs(PlayerRef.GetHeadingAngle(DummyObject))
    if angle <= OutAngle
        if angle>90
            RegisterForSingleUpdate(0.3)
        else
            RegisterForSingleUpdate(UpdateDelay)
        endif
    else 
        StopLookCam()
	endIf
endFunction
